﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Moway;

// programme exemple permettant de réaliser le programme de détection d'obstacle
namespace Defi
{
    public partial class Form_pilotage_Moway : Form
    {
        private RobotMoway Robot = new RobotMoway(0,2);
        
        public Form_pilotage_Moway()
        {
            InitializeComponent();
        }

        private void button_quitter_Click(object sender, EventArgs e)
        {
            Robot.RFdeconnect();
            timer1.Stop();
            this.Close();
        }

        private void button_connecter_Click(object sender, EventArgs e)
        {
            Robot.RFconnect();
            timer1.Enabled = true;
        }

        private void buttonDeconnecter_Click(object sender, EventArgs e)
        {
            Robot.RFdeconnect();
        }

        
        private void timer1_Tick(object sender, EventArgs e)
        {
            Robot.avancer(50); //Le robot avance jusqu'à détecter un obstacle

            if ((Robot.Obstacle_Central_D > 0) || (Robot.Obstacle_Central_G > 0) ||
                (Robot.Obstacle_Lateral_D > 0) || (Robot.Obstacle_Lateral_G > 0)) //Condition détection d'obstacle
            {
                Robot.stop(); //Arrêt du robot si détection d'obstacle.

                for (int i = 0; i < 3; i++) // Bip *3 du robot.
                {
                    Robot.son_on();
                    System.Threading.Thread.Sleep(500); //Pause de 0.5 sec.
                    Robot.son_off();
                    System.Threading.Thread.Sleep(500); //Pause de 0.5 sec.
                }

                timer1.Stop(); //Arrêt du timer quand le robot a détecté un obstacle.
            }
        }

        // lancement du timer et donc du défi
        private void button_defi_Click(object sender, EventArgs e)
        {
            timer1.Start();
        }
    }
}
