﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Moway;

// Application permettant de piloter un robot Moway via  la radiofréquence en C#

namespace PilotageMoway
{
    public partial class Form_pilotage_Moway : Form
    {
        private RobotMoway Robot = new RobotMoway(0,2);
        private byte vitesse = 0;

        public Form_pilotage_Moway()
        {
            InitializeComponent();
            textBoxVitesse.Text = vitesse.ToString();
        }

        private void button_quitter_Click(object sender, EventArgs e)
        {
            Robot.RFdeconnect();
            timer1.Stop();
            this.Close();
        }

        private void button_connecter_Click(object sender, EventArgs e)
        {
            Robot.RFconnect();
            timer1.Enabled = true;
            timer1.Start();
        }

        private void buttonDeconnecter_Click(object sender, EventArgs e)
        {
            Robot.RFdeconnect();
        }

        private void button_avant_Click(object sender, EventArgs e)
        {
            Robot.avancer(vitesse);
        }

        private void button_droite_Click(object sender, EventArgs e)
        {
            Robot.tourner_droite(vitesse);
        }

        private void button_gauche_Click(object sender, EventArgs e)
        {
            Robot.tourner_gauche(vitesse);
        }

        private void button_arriere_Click(object sender, EventArgs e)
        {
            Robot.reculer(vitesse);
        }

        private void button_stop_Click(object sender, EventArgs e)
        {
            Robot.stop();
        }

        private void checkBox_led_avant_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox_led_avant.Checked == true)
                Robot.allumer_led_avant();
            else
                Robot.eteindre_led_avant();
        }

        private void checkBox_led_arriere_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox_led_arriere.Checked == true)
                Robot.allumer_led_arriere();
            else
                Robot.eteindre_led_arriere();
        }

        private void checkBox_led_rouge_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox_led_rouge.Checked == true)
                Robot.allumer_led_rouge();
            else
                Robot.eteindre_led_rouge();
        }

        private void checkBox_led_verte_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox_led_verte.Checked == true)
                Robot.allumer_led_verte();
            else
                Robot.eteindre_led_verte();
        }

        private void trackBarVitesse_Scroll(object sender, EventArgs e)
        {
            vitesse = Convert.ToByte(trackBarVitesse.Value);
            textBoxVitesse.Text = vitesse.ToString();
        }
        

        // Le timer permet de réactualiser la valeur des capteurs dans les textbox
        private void timer1_Tick(object sender, EventArgs e)
        {
            textBoxObstacleG.Text = Robot.Obstacle_Lateral_G.ToString();
            textBoxObstacleAVG.Text = Robot.Obstacle_Central_G.ToString();
            textBoxObstacleAVD.Text = Robot.Obstacle_Central_D.ToString();
            textBoxObstacleD.Text = Robot.Obstacle_Lateral_D.ToString();
        }
    }
}
