;***************************************************************************
;*                              mowayWorld                                 *
;***************************************************************************
;*Description:                                                             *
;*Automatically generated code                                             *
;***************************************************************************
;***************************************************************************
	list p=18F86j50
   ;*	Include mOways microcontroller
   #include "inc\P18F86j50.INC"

;****************************************
;*   Variables                          *
;****************************************
AdrSender      EQU    0x7E 
Data0          EQU    0x7D 
Data1          EQU    0x7C 
Data2          EQU    0x7B 
Data3          EQU    0x7A 
Data4          EQU    0x79 
Data5          EQU    0x78 
Data6          EQU    0x77 
Data7          EQU    0x76 
Data8          EQU    0x75 
DataSend0      EQU    0x74 
DataSend1      EQU    0x73 
DataSend2      EQU    0x72 
DataSend3      EQU    0x71 
DataSend4      EQU    0x70 
DataSend5      EQU    0x6F 
DataSend6      EQU    0x6E 
DataSend7      EQU    0x6D 

;*	Reset Vector
  org		0x1000
  goto	INIT
;*	Program memory	*
  org		0x102A
;************************
;***************************[MOWAY LIBRARIES]*********************************************
  #include "inc\lib_sen_moway_GUI.inc"
  #include "inc\lib_rf2gh4_GUI.inc"
  #include "inc\lib_mot_moway_GUI.inc"
  #include "inc\lib_cam_moway_GUI.inc"
;*************************************

INIT:

;#####################################
  ;*************************[MOWAY CONFIGURATION]***********************
  ;Sensor configuration
  call    SEN_CONFIG
  ;Motor configuration
  call    MOT_CONFIG

;****************************************
;*   Variables initialization           *
;****************************************
  movlw   .0
  movwf    AdrSender
  movlw   .0
  movwf    Data0
  movlw   .0
  movwf    Data1
  movlw   .0
  movwf    Data2
  movlw   .0
  movwf    Data3
  movlw   .0
  movwf    Data4
  movlw   .0
  movwf    Data5
  movlw   .0
  movwf    Data6
  movlw   .0
  movwf    Data7
  movlw   .0
  movwf    Data8
  movlw   .0
  movwf    DataSend0
  movlw   .0
  movwf    DataSend1
  movlw   .0
  movwf    DataSend2
  movlw   .0
  movwf    DataSend3
  movlw   .0
  movwf    DataSend4
  movlw   .0
  movwf    DataSend5
  movlw   .0
  movwf    DataSend6
  movlw   .0
  movwf    DataSend7


label0:
;************Module RfActivation****************************************

;***********************************************************************

;Configuration of SPI
  call	    RF_CONFIG_SPI

;Configuration of RF module (channel and dir)
  movlw	    .2		;Dir
  movwf	    RF_DIR			
  movlw	    .0		;Channel
  movwf	    RF_CHN			
  call	    RF_CONFIG
	btfss	RF_STATUS,CONFIGOK
  goto    label0

;Activate the module	
  call	    RF_ON
	btfss	RF_STATUS,ONOK
  goto    label0

label1:
;************Module RfReceive********************************************

;***********************************************************************

  call		RF_RECEIVE	
  btfss		RF_STATUS,RCVOK
  goto    label2
  movf     RF_DIR_IN,W
  movwf    AdrSender
  movf     RF_DATA_IN_0,W
  movwf    Data0
  movf     RF_DATA_IN_1,W
  movwf    Data1
  movf     RF_DATA_IN_2,W
  movwf    Data2
  movf     RF_DATA_IN_3,W
  movwf    Data3
  movf     RF_DATA_IN_4,W
  movwf    Data4
  movf     RF_DATA_IN_5,W
  movwf    Data5
  movf     RF_DATA_IN_6,W
  movwf    Data6
  movf     RF_DATA_IN_7,W
  movwf    Data7

;***********************************************************************

;LLamada a subutina
    call    Reception


label2:
;LLamada a subutina
    call    Emission


  goto    label1


  goto    label2


Emission:
;************Module Assigned********************************************

;***********************************************************************

  movlw   .1
  movwf   DataSend0

;***********************************************************************
;********************Module Assign Brightness***************************

;***********************************************************************
  call    SEN_LIGHT
  movf    SEN_LIGHT_P,W
  movwf   DataSend1

;***********************************************************************
;************************Module Assign Line*****************************

;***********************************************************************
  call    SEN_LINE_ANALOG
  movf    SEN_LINE_L,W
  movwf   DataSend2

;***********************************************************************
;************************Module Assign Line*****************************

;***********************************************************************
  call    SEN_LINE_ANALOG
  movf    SEN_LINE_R,W
  movwf   DataSend3

;***********************************************************************
;*********************Module Assign Obstacle****************************

;***********************************************************************
  bcf		SEN_CHECK_OBS,OBS_CENTER_R
  bcf		SEN_CHECK_OBS,OBS_SIDE_R
  bsf		SEN_CHECK_OBS,OBS_CENTER_L
  bcf		SEN_CHECK_OBS,OBS_SIDE_L
  call 	SEN_OBS_ANALOG
  movf    SEN_OBS_CENTER_L,W
  movwf   DataSend4

;***********************************************************************
;*********************Module Assign Obstacle****************************

;***********************************************************************
  bsf		SEN_CHECK_OBS,OBS_CENTER_R
  bcf		SEN_CHECK_OBS,OBS_SIDE_R
  bcf		SEN_CHECK_OBS,OBS_CENTER_L
  bcf		SEN_CHECK_OBS,OBS_SIDE_L
  call 	SEN_OBS_ANALOG
  movf    SEN_OBS_CENTER_R,W
  movwf   DataSend5

;***********************************************************************
;*********************Module Assign Obstacle****************************

;***********************************************************************
  bcf		SEN_CHECK_OBS,OBS_CENTER_R
  bcf		SEN_CHECK_OBS,OBS_SIDE_R
  bcf		SEN_CHECK_OBS,OBS_CENTER_L
  bsf		SEN_CHECK_OBS,OBS_SIDE_L
  call 	SEN_OBS_ANALOG
  movf    SEN_OBS_SIDE_L,W
  movwf   DataSend6

;***********************************************************************
;*********************Module Assign Obstacle****************************

;***********************************************************************
  bcf		SEN_CHECK_OBS,OBS_CENTER_R
  bsf		SEN_CHECK_OBS,OBS_SIDE_R
  bcf		SEN_CHECK_OBS,OBS_CENTER_L
  bcf		SEN_CHECK_OBS,OBS_SIDE_L
  call 	SEN_OBS_ANALOG
  movf    SEN_OBS_SIDE_R,W
  movwf   DataSend7

;***********************************************************************
;************Module RfTransmit********************************************

;***********************************************************************

  movlw       .2		;Dir of receptor
  movwf	    RF_DIR_OUT
			;Data to send		

  movf     DataSend0,W
  movwf	    RF_DATA_OUT_0
  movf     DataSend1,W
  movwf	    RF_DATA_OUT_1
  movf     DataSend2,W
  movwf	    RF_DATA_OUT_2
  movf     DataSend3,W
  movwf	    RF_DATA_OUT_3
  movf     DataSend4,W
  movwf	    RF_DATA_OUT_4
  movf     DataSend5,W
  movwf	    RF_DATA_OUT_5
  movf     DataSend6,W
  movwf	    RF_DATA_OUT_6
  movf     DataSend7,W
  movwf	    RF_DATA_OUT_7

  call	    RF_SEND		;Send
  btfss	    RF_STATUS,SNDOK
  goto    label3
  btfss	    RF_STATUS,ACK	
  goto    label3


;***********************************************************************

label3:
;************Module Assigned********************************************

;***********************************************************************

  movlw   .2
  movwf   DataSend0

;***********************************************************************
;********************Module Assign Battery******************************

;***********************************************************************
  call    SEN_BATTERY
  movf    SEN_BATTERY_P,W
  movwf   DataSend1

;***********************************************************************
;***********************Module Assign Noise*****************************

;***********************************************************************
  call    SEN_MIC_ANALOG
  movf    SEN_MIC,W
  movwf   DataSend2

;***********************************************************************
;**************Module Assign Accelerometer******************************

;***********************************************************************
  call    SEN_ACCE_XYZ_READ
  movf    SEN_ACCE_X,W
  movwf   DataSend3

;***********************************************************************
;**************Module Assign Accelerometer******************************

;***********************************************************************
  call    SEN_ACCE_XYZ_READ
  movf    SEN_ACCE_Y,W
  movwf   DataSend3

;***********************************************************************
;**************Module Assign Accelerometer******************************

;***********************************************************************
  call    SEN_ACCE_XYZ_READ
  movf    SEN_ACCE_Z,W
  movwf   DataSend3

;***********************************************************************
;*****************Module Assign Temperature*****************************

;***********************************************************************
  call    SEN_TEMPERATURE
  movf    SEN_TEMPERATURE_C,W
  movwf   DataSend6

;***********************************************************************
;************Module Assigned********************************************

;***********************************************************************

  movlw   .0
  movwf   DataSend7

;***********************************************************************
;************Module RfTransmit********************************************

;***********************************************************************

  movlw       .2		;Dir of receptor
  movwf	    RF_DIR_OUT
			;Data to send		

  movf     DataSend0,W
  movwf	    RF_DATA_OUT_0
  movf     DataSend1,W
  movwf	    RF_DATA_OUT_1
  movf     DataSend2,W
  movwf	    RF_DATA_OUT_2
  movf     DataSend3,W
  movwf	    RF_DATA_OUT_3
  movf     DataSend4,W
  movwf	    RF_DATA_OUT_4
  movf     DataSend5,W
  movwf	    RF_DATA_OUT_5
  movf     DataSend6,W
  movwf	    RF_DATA_OUT_6
  movf     DataSend7,W
  movwf	    RF_DATA_OUT_7

  call	    RF_SEND		;Send
  btfss	    RF_STATUS,SNDOK
  goto    label4
  btfss	    RF_STATUS,ACK	
  goto    label4


;***********************************************************************

label4:
;************Module Assigned********************************************

;***********************************************************************

  movlw   .3
  movwf   DataSend0

;***********************************************************************
;************************Module Assign Time*****************************

;***********************************************************************
  movlw   STATUS_T
  movwf   MOT_STATUS_COM
  call    MOT_FDBCK

  movf    MOT_STATUS_DATA_0,W
  movwf   DataSend1

;***********************************************************************
;***********************Module Assign Speed*****************************

;***********************************************************************
  movlw   STATUS_V_L
  movwf   MOT_STATUS_COM
  call    MOT_FDBCK

  movf    MOT_STATUS_DATA_0,W
  movwf   DataSend2

;***********************************************************************
;***********************Module Assign Speed*****************************

;***********************************************************************
  movlw   STATUS_V_R
  movwf   MOT_STATUS_COM
  call    MOT_FDBCK

  movf    MOT_STATUS_DATA_0,W
  movwf   DataSend3

;***********************************************************************
;**********************Module Assign Distance***************************

;***********************************************************************
  movlw   STATUS_KM
  movwf   MOT_STATUS_COM
  call    MOT_FDBCK

  movf    MOT_STATUS_DATA_0,W
  movwf   DataSend4

;***********************************************************************
;**********************Module Assign Angle******************************

;***********************************************************************
  movlw   STATUS_A
  movwf   MOT_STATUS_COM
  call    MOT_FDBCK

  movf    MOT_STATUS_DATA_0,W
  movwf   DataSend5

;***********************************************************************
;************Module Assigned********************************************

;***********************************************************************

  movlw   .0
  movwf   DataSend6

;***********************************************************************
;************Module Assigned********************************************

;***********************************************************************

  movlw   .0
  movwf   DataSend7

;***********************************************************************
;************Module RfTransmit********************************************

;***********************************************************************

  movlw       .2		;Dir of receptor
  movwf	    RF_DIR_OUT
			;Data to send		

  movf     DataSend0,W
  movwf	    RF_DATA_OUT_0
  movf     DataSend1,W
  movwf	    RF_DATA_OUT_1
  movf     DataSend2,W
  movwf	    RF_DATA_OUT_2
  movf     DataSend3,W
  movwf	    RF_DATA_OUT_3
  movf     DataSend4,W
  movwf	    RF_DATA_OUT_4
  movf     DataSend5,W
  movwf	    RF_DATA_OUT_5
  movf     DataSend6,W
  movwf	    RF_DATA_OUT_6
  movf     DataSend7,W
  movwf	    RF_DATA_OUT_7

  call	    RF_SEND		;Send
  btfss	    RF_STATUS,SNDOK
  return
  btfss	    RF_STATUS,ACK	
  return


;***********************************************************************
  return

  goto    label3


  goto    label4


Reception:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .0
  btfss   STATUS,Z
  goto    label5

;***********************************************************************
;************Module Stop************************************************

;***********************************************************************

;   Call STOP 
    call    MOT_STOP

;***********************************************************************

  return

label5:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .1
  btfss   STATUS,Z
  goto    label6

;***********************************************************************
;************Module FreeAction*******************************************

;***********************************************************************

;*************************[Left motor]******************************
  movf   Data1,W
  movwf   MOT_VEL
  bsf     MOT_CON,COMTYPE
  movlw   .0
  movwf   MOT_T_DIST_ANG
  bsf     MOT_CON,FWDBACK
  bcf     MOT_CON,RL
  call    MOT_CHA_VEL
;*************************[Right motor]********************************
  movf   Data2,W
  movwf   MOT_VEL
  bsf     MOT_CON,COMTYPE
  movlw   .0
  movwf   MOT_T_DIST_ANG
  bsf     MOT_CON,FWDBACK
  bsf     MOT_CON,RL
  call    MOT_CHA_VEL

;***********************************************************************

  return

label6:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .2
  btfss   STATUS,Z
  goto    label7

;***********************************************************************
;************Module FreeAction*******************************************

;***********************************************************************

;*************************[Left motor]******************************
  movf   Data1,W
  movwf   MOT_VEL
  bsf     MOT_CON,COMTYPE
  movlw   .0
  movwf   MOT_T_DIST_ANG
  bcf     MOT_CON,FWDBACK
  bcf     MOT_CON,RL
  call    MOT_CHA_VEL
;*************************[Right motor]********************************
  movf   Data2,W
  movwf   MOT_VEL
  bsf     MOT_CON,COMTYPE
  movlw   .0
  movwf   MOT_T_DIST_ANG
  bcf     MOT_CON,FWDBACK
  bsf     MOT_CON,RL
  call    MOT_CHA_VEL

;***********************************************************************

  return

label7:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .3
  btfss   STATUS,Z
  goto    label8

;***********************************************************************
;************Module FreeAction*******************************************

;***********************************************************************

;*************************[Left motor]******************************
  movf   Data1,W
  movwf   MOT_VEL
  bsf     MOT_CON,COMTYPE
  movlw   .0
  movwf   MOT_T_DIST_ANG
  bcf     MOT_CON,FWDBACK
  bcf     MOT_CON,RL
  call    MOT_CHA_VEL
;*************************[Right motor]********************************
  movf   Data2,W
  movwf   MOT_VEL
  bsf     MOT_CON,COMTYPE
  movlw   .0
  movwf   MOT_T_DIST_ANG
  bsf     MOT_CON,FWDBACK
  bsf     MOT_CON,RL
  call    MOT_CHA_VEL

;***********************************************************************

  return

label8:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .4
  btfss   STATUS,Z
  goto    label9

;***********************************************************************
;************Module FreeAction*******************************************

;***********************************************************************

;*************************[Left motor]******************************
  movf   Data1,W
  movwf   MOT_VEL
  bsf     MOT_CON,COMTYPE
  movlw   .0
  movwf   MOT_T_DIST_ANG
  bsf     MOT_CON,FWDBACK
  bcf     MOT_CON,RL
  call    MOT_CHA_VEL
;*************************[Right motor]********************************
  movf   Data2,W
  movwf   MOT_VEL
  bsf     MOT_CON,COMTYPE
  movlw   .0
  movwf   MOT_T_DIST_ANG
  bcf     MOT_CON,FWDBACK
  bsf     MOT_CON,RL
  call    MOT_CHA_VEL

;***********************************************************************

  return

label9:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .30
  btfss   STATUS,Z
  goto    label10

;***********************************************************************
;************Module Leds************************************************

;***********************************************************************

  call    LED_FRONT_ON

;***********************************************************************

  return

label10:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .31
  btfss   STATUS,Z
  goto    label11

;***********************************************************************
;************Module Leds************************************************

;***********************************************************************

  call    LED_FRONT_OFF

;***********************************************************************

  return

label11:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .32
  btfss   STATUS,Z
  goto    label12

;***********************************************************************
;************Module Leds************************************************

;***********************************************************************

  call    LED_BRAKE_ON

;***********************************************************************

  return

label12:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .33
  btfss   STATUS,Z
  goto    label13

;***********************************************************************
;************Module Leds************************************************

;***********************************************************************

  call    LED_BRAKE_OFF

;***********************************************************************

  return

label13:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .34
  btfss   STATUS,Z
  goto    label14

;***********************************************************************
;************Module Leds************************************************

;***********************************************************************

  call    LED_TOP_GREEN_ON

;***********************************************************************

  return

label14:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .35
  btfss   STATUS,Z
  goto    label15

;***********************************************************************
;************Module Leds************************************************

;***********************************************************************

  call    LED_TOP_GREEN_OFF

;***********************************************************************

  return

label15:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .36
  btfss   STATUS,Z
  goto    label16

;***********************************************************************
;************Module Leds************************************************

;***********************************************************************

  call    LED_TOP_RED_ON

;***********************************************************************

  return

label16:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .37
  btfss   STATUS,Z
  goto    label17

;***********************************************************************
;************Module Leds************************************************

;***********************************************************************

  call    LED_TOP_RED_OFF

;***********************************************************************

  return

label17:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .38
  btfss   STATUS,Z
  goto    label18

;***********************************************************************
;************Module Leds************************************************

;***********************************************************************

  call    LED_FRONT_OFF
  call    LED_BRAKE_OFF
  call    LED_TOP_GREEN_OFF
  call    LED_TOP_RED_OFF

;***********************************************************************

  return

label18:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .50
  btfss   STATUS,Z
  goto    label19

;***********************************************************************
;************Module Speaker*********************************************

;***********************************************************************

  movf   Data3,W
  movwf	SEN_SPEAKER_FREQ
  movlw	SPEAKER_ON
  movwf	SEN_SPEAKER_ON_OFF
  call	SEN_SPEAKER

;***********************************************************************

  return

label19:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .51
  btfss   STATUS,Z
  goto    label20

;***********************************************************************
;************Module Stop Speaker****************************************

;***********************************************************************

  movlw	SPEAKER_OFF
  movwf	SEN_SPEAKER_ON_OFF
  call	SEN_SPEAKER

;***********************************************************************

  return

label20:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .20
  btfss   STATUS,Z
  goto    label21

;***********************************************************************
;************Module ResetMoveInformation********************************

;***********************************************************************

  movlw   RST_KM
  movwf   MOT_RST_COM
  call    MOT_RST
  movlw   RST_D
  movwf   MOT_RST_COM
  call    MOT_RST

;***********************************************************************

  return

label21:
;************Module Comparative*******************************************

;************************************************************************

  movf   Data0,W
  sublw   .21
  btfss   STATUS,Z
  return

;***********************************************************************
;************Module ResetMoveInformation********************************

;***********************************************************************

  movlw   RST_T
  movwf   MOT_RST_COM
  call    MOT_RST

;***********************************************************************

  return

END
